Package weka.clusterers

# Class MakeDensityBasedClusterer

java.lang.Object
weka.clusterers.AbstractClusterer
weka.clusterers.AbstractDensityBasedClusterer
weka.clusterers.MakeDensityBasedClusterer

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Clusterer`, `DensityBasedClusterer`, `NumberOfClustersRequestable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `WeightedInstancesHandler`

public class MakeDensityBasedClusterer extends AbstractDensityBasedClusterer implements NumberOfClustersRequestable, OptionHandler, WeightedInstancesHandler
Class for wrapping a Clusterer to make it return a distribution and density. Fits normal distributions and discrete distributions within each cluster produced by the wrapped clusterer. Supports the NumberOfClustersRequestable interface only if the wrapped Clusterer does.

Valid options are:

     -M <num>
      minimum allowable standard deviation for normal density computation
      (default 1e-6)

     -W <clusterer name>
      Clusterer to wrap.
      (default weka.clusterers.SimpleKMeans)

     Options specific to clusterer weka.clusterers.SimpleKMeans:

     -N <num>
      number of clusters.
      (default 2).

     -V
      Display std. deviations for centroids.

     -M
      Replace missing values with mean/mode.

     -S <num>
      Random number seed.
      (default 10)

Options after "--" are passed on to the base clusterer.

Version:
  $Revision: 5538 $
Author:
  Richard Kirkby (rkirkby@cs.waikato.ac.nz), Mark Hall (mhall@cs.waikato.ac.nz), Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`MakeDensityBasedClusterer()`
Default constructor.
`MakeDensityBasedClusterer(Clusterer toWrap)`
Contructs a MakeDensityBasedClusterer wrapping a given Clusterer.

## Method Summary

Modifier and Type
Method
Description
`void`
`buildClusterer(Instances data)`
Builds a clusterer for a set of instances.
`String`
`clustererTipText()`
Returns the tip text for this property
`double[]`
`clusterPriors()`
Returns the cluster priors.
`Capabilities`
`getCapabilities()`
Returns default capabilities of the clusterer (i.e., of the wrapper clusterer).
`Clusterer`
`getClusterer()`
Gets the clusterer being wrapped.
`double`
`getMinStdDev()`
Get the minimum allowable standard deviation.
`String[]`
`getOptions()`
Gets the current settings of the clusterer.
`String`
`getRevision()`
Returns the revision string.
`String`
`globalInfo()`
Returns a string describing classifier
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options..
`double[]`
`logDensityPerClusterForInstance(Instance inst)`
Computes the log of the conditional density (per cluster) for a given instance.
`static void`
`main(String[] argv)`
Main method for testing this class.
`String`
`minStdDevTipText()`
Returns the tip text for this property
`int`
`numberOfClusters()`
Returns the number of clusters.
`void`
`setClusterer(Clusterer toWrap)`
Sets the clusterer to wrap.
`void`
`setMinStdDev(double m)`
Set the minimum value for standard deviation when calculating normal density.
`void`
`setNumClusters(int n)`
Set the number of clusters to generate.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`String`
`toString()`
Returns a description of the clusterer.

### Methods inherited from class weka.clusterers.AbstractDensityBasedClusterer

`distributionForInstance, logDensityForInstance, logJointDensitiesForInstance, makeCopies`

### Methods inherited from class weka.clusterers.AbstractClusterer

`clusterInstance, forName, makeCopies, makeCopy`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface weka.clusterers.Clusterer

`clusterInstance`

## Constructor Details

### MakeDensityBasedClusterer

public MakeDensityBasedClusterer()
Default constructor.

### MakeDensityBasedClusterer

public MakeDensityBasedClusterer(Clusterer toWrap)
Contructs a MakeDensityBasedClusterer wrapping a given Clusterer.

Parameters:
  `toWrap` - the clusterer to wrap around

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing classifier

Returns:
  a description suitable for displaying in the explorer/experimenter gui

### setNumClusters

public void setNumClusters(int n) throws Exception
Set the number of clusters to generate.

Specified by:
  `setNumClusters` in interface `NumberOfClustersRequestable`
Parameters:
  `n` - the number of clusters to generate
Throws:
  `Exception` - if the wrapped clusterer has not been set, or if the wrapped clusterer does not implement this facility.

### getCapabilities

public Capabilities getCapabilities()
Returns default capabilities of the clusterer (i.e., of the wrapper clusterer).

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Specified by:
  `getCapabilities` in interface `Clusterer`
Overrides:
  `getCapabilities` in class `AbstractClusterer`
Returns:
  the capabilities of this clusterer
See Also:
  - `Capabilities`

### buildClusterer

public void buildClusterer(Instances data) throws Exception
Builds a clusterer for a set of instances.

Specified by:
  `buildClusterer` in interface `Clusterer`
Specified by:
  `buildClusterer` in class `AbstractClusterer`
Parameters:
  `data` - the instances to train the clusterer with
Throws:
  `Exception` - if the clusterer hasn't been set or something goes wrong

### clusterPriors

public double[] clusterPriors()
Returns the cluster priors.

Specified by:
  `clusterPriors` in interface `DensityBasedClusterer`
Specified by:
  `clusterPriors` in class `AbstractDensityBasedClusterer`
Returns:
  the cluster priors

### logDensityPerClusterForInstance

public double[] logDensityPerClusterForInstance(Instance inst) throws Exception
Computes the log of the conditional density (per cluster) for a given instance.

Specified by:
  `logDensityPerClusterForInstance` in interface `DensityBasedClusterer`
Specified by:
  `logDensityPerClusterForInstance` in class `AbstractDensityBasedClusterer`
Parameters:
  `inst` - the instance to compute the density for
Returns:
  an array containing the estimated densities
Throws:
  `Exception` - if the density could not be computed successfully

### numberOfClusters

public int numberOfClusters() throws Exception
Returns the number of clusters.

Specified by:
  `numberOfClusters` in interface `Clusterer`
Specified by:
  `numberOfClusters` in class `AbstractClusterer`
Returns:
  the number of clusters generated for a training dataset.
Throws:
  `Exception` - if number of clusters could not be returned successfully

### toString

public String toString()
Returns a description of the clusterer.

Overrides:
  `toString` in class `Object`
Returns:
  a string containing a description of the clusterer

### clustererTipText

public String clustererTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setClusterer

public void setClusterer(Clusterer toWrap)
Sets the clusterer to wrap.

Parameters:
  `toWrap` - the clusterer

### getClusterer

public Clusterer getClusterer()
Gets the clusterer being wrapped.

Returns:
  the clusterer

### minStdDevTipText

public String minStdDevTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setMinStdDev

public void setMinStdDev(double m)
Set the minimum value for standard deviation when calculating normal density. Reducing this value can help prevent arithmetic overflow resulting from multiplying large densities (arising from small standard deviations) when there are many singleton or near singleton values.

Parameters:
  `m` - minimum value for standard deviation

### getMinStdDev

public double getMinStdDev()
Get the minimum allowable standard deviation.

Returns:
  the minumum allowable standard deviation

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options..

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options.

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -M <num>
      minimum allowable standard deviation for normal density computation
      (default 1e-6)

     -W <clusterer name>
      Clusterer to wrap.
      (default weka.clusterers.SimpleKMeans)

     Options specific to clusterer weka.clusterers.SimpleKMeans:

     -N <num>
      number of clusters.
      (default 2).

     -V
      Display std. deviations for centroids.

     -M
      Replace missing values with mean/mode.

     -S <num>
      Random number seed.
      (default 10)

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the clusterer.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions()

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `AbstractClusterer`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - the options